/*========================================================================
                              
                                ** UMOP **
		** Universal Multi-Agent OBDD-based Planner **

            Copyright (C) 1999 by Rune M. Jensen and Manuela M. Veloso
            Computer Science Department, Carnegie Mellon University.
            
    Permission is hereby granted to distribute the UMOP software for 
    research purposes, provided this notice is included with any such 
    distribution. 

      *** WE ARE NOT RESPONSIBLE FOR ANY KIND OF DAMAGE TO YOUR  ***
      *** FILES, DATA, HARDWARE, LOSS OF MONEY, SYSTEM CRASHES   *** 
      *** OR ANY OTHER THING YOU MIGHT COME UP WITH.             ***
      *** - USE THIS PROGRAM OF YOUR OWN FREE WILL !!!           ***

========================================================================*/
/****************************************************** 
 * File  : set.hpp   
 * Desc. : STL string set manipulation functions
 *         See e.g. "Using the STL, The C++ Standard Template 
 *         Library" by Robert Robson, sec. edit., Springer, 1999
 *         for an in depth discussion of these algorithms.
 * Author: Rune M. Jensen
 * Date  : 10/23/00
 ******************************************************/
#include<string>
#include<set>


  
  
// prototypes
void strprint(set<string> s);                                     // prints a set of strings as a list
bool strmember(set<string> s,string e);                           // set member
set<string> strunion(set<string> s1,set<string> s2);              // set union
set<string> strintersection(set<string> s1,set<string> s2);       // set intersection
set<string> strdifference(set<string> s1,set<string> s2);         // set difference (s1 - s2
set<string> strsymmetricdifference(set<string> s1,set<string> s2);// set symmetric difference (union - intersection)
